/***************
adevs, a library supporting discrete event simulation
Copyright (C) 1999, 2000 James Nutaro

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

Bugs, comments, and questions can be sent to nutaro@ece.arizona.edu
***************/
/**
The atomic class should be sub-classed by the modeler to create
atomic simulation models.
*/

class atomic: public devs {

public:		
/// Creates an atomic component with an empty name string.
		atomic ():devs (devs::ATOMIC) { }
/// Creates an atomic component and assigns it the indicated name.
		atomic (const char* name):devs (name, devs::ATOMIC) { }
/// Set the initial state of the atomic model
		virtual void reset () = 0;
/// internal transition function
		virtual void delta_int () = 0;
/// external transition functions
		virtual void delta_ext () = 0;
/// confluent transition function
		virtual void delta_conf () = 0;
/// output function
		virtual void output_func () = 0;
/**
Lookahead function.  Returns the lookahead for the current state (default is 0).
A lookahead less than zero is treated as zero by the simulation engine.
*/
		virtual stime_t lookahead () const { return 0.0; }
/// This method supports the simulator
		void _reset (stime_t t0);

};
