/***************
adevs, a library supporting discrete event simulation
Copyright (C) 2001 James Nutaro

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

Bugs, comments, and questions can be sent to nutaro@ece.arizona.edu
***************/
/**
Wrapper class around an OS native thread.  This implementation assumes
a POSIX pthreads compliant interface to the native thread library.
*/
class Thread: public object {

public:		
/// Create an idle thread
		Thread ();
/**
Run the supplied function using the given argument.  The thread reverts
to idle when the function returns.  Trying to use a single Thread to
run multiple functions concurrently will have an undefined (and probably
undesirable) effect.
*/
		void run (void(*func)(void*), void* arg);
/**
Delete the thread.  If the thread is running, it will terminate
when the function returns.
*/
		~Thread ();
private:
// Idling mutex
		Mutex mtx;
// Thread for doing processing.
		#ifdef PARALLEL_POSIX
		pthread_t thr;
		#endif
// Function to execute in the thread
		void (*func)(void*);
// Argument passed to the function
		void* arg;
// Main loop for the thread
		friend void* exec_func (void* arg);

};
