/***************
adevs, a library supporting discrete event simulation
Copyright (C) 1999, 2000, 2001 James Nutaro

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

Bugs, comments, and questions can be sent to nutaro@ece.arizona.edu
***************/
/**
A collection of objects.  The class provides facilities
for rapid membership testing, member->index mapping,
and instance counts.  Instances of objects in the collection
must exist, or method calls are likely to fail.
*/
class collection: public indexed {
	public:
		collection();
		collection(unsigned capacity, unsigned grow = DEFAULT_CONTAINER_GROWTH);
		collection(const collection &src);
		virtual void swap(unsigned i, unsigned j);
		virtual void empty();
		virtual void add(object *obj);
		virtual object* remove(unsigned index);
		virtual void removeAll();
		/// Returns the number of occurances of the object in the collection
	 	unsigned instanceCount(const object &obj) const;
		/// Returns the index of the object.
		unsigned indexOf(const object &obj) const;
		virtual ~collection();

	private:	
		hashtable *_table;
};
