/***************
adevs, a library supporting discrete event simulation
Copyright (C) 1999, 2000, 2001 James Nutaro

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

Bugs, comments, and questions can be sent to nutaro@ece.arizona.edu
***************/
/**
The object class is a base class for all objects that will
comprise (or be insertable into) the container classes.
Derived classes should only provide references to overloaded operators.
*/
class object {
	public:
		inline object() {}
		/**
		Tests for address equality. e.g object * == object * returns
		the same value as object & == object & 
		*/
		virtual bool operator==(const object &obj) const;
		virtual bool operator!=(const object &obj) const;
		/**
		Returns an unsigned int used as a hash key.
		Two objects for whom == returns true should produce the
		same hash key.  Default returns the objects address.
		*/
		virtual unsigned int hashcode() const;
		/**
		Should return a copy of this object, or throw CloneException if the operation
		is not supported.
		*/
		virtual object* clone() const;
		virtual ~object();
};
