/***************
adevs, a library supporting discrete event simulation
Copyright (C) 1999, 2000 James Nutaro

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

Bugs, comments, and questions can be sent to nutaro@ece.arizona.edu
***************/
/**
A FIFO queue.
*/
class queue: public object {
	public:		
		/// Creates an empty queue.
		queue();
		/// Returns the length of the queue.
		inline unsigned getSize() { return length; }
		/// Returns the length of the queue.
		inline unsigned getLength() { return length; }
		/// Adds an item to the end of the queue.
		void add(object* item);
		/**
		Removes and then returns the first item in the queue.
		Returns NULL if the queue is empty.
		*/
		object* remove();
		/// Deletes all objects in the queue and sets length to 0.
		void empty();
		~queue();

	private:	
		struct _item {
			struct _item* next;
			object* item;
		};
		struct _item* head;
		struct _item* tail;
		unsigned length;
};
