/***************
adevs, a library supporting discrete event simulation
Copyright (C) 1999, 2000 James Nutaro

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

Bugs, comments, and questions can be sent to nutaro@ece.arizona.edu
***************/
#include <adevs/adevs.h>
using namespace adevs;

coupled::coupled ():devsn () { }
coupled::coupled (const char* name):devsn (name) { }

void coupled::add (devs* model) {

if (model == this) {
   FeedbackException err (this);
   throw err;
   }

components.add (model);

}

const set* coupled::getComponents () const {

return &components;

}

void coupled::makeStructureChanges (set& new_models, set& old_models) { }

coupled::~coupled () {

components.empty ();

}
