/***************
adevs, a library supporting discrete event simulation
Copyright (C) 1999, 2000, 2001 James Nutaro

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

Bugs, comments, and questions can be sent to nutaro@ece.arizona.edu
***************/
#include <adevs/adevs.h>
using namespace adevs;

simulator::simulator (SimType type):object () { 

typeCode = type;
model = NULL; 

}

void simulator::input (port_t inport, object* value) {

model->input (inport, value);

}

bag* simulator::outputOnPort (port_t outport) {

return model->outputOnPort (outport);

}

const port_t* simulator::outputPorts (int* count) { 

return model->outputPorts (count);

}

void simulator::endOfCycle (indexed& garbage) {

model->clearPorts (garbage);

}

stime_t simulator::timeNext () {

return model->timeNext ();

}

stime_t simulator::sigma () {

return model->sigma ();

}
 
stime_t simulator::timeLast () {

return model->timeLast ();

}

void simulator::setModel (devs* model) {

this->model = model;

}

devs* simulator::getModel () {

return model;

}

simulator::~simulator () { }
