#include <adevs/adevs.h>
#include <assert.h>
#include <iostream>
using namespace adevs;

#define ARRAY_SIZE 100

int main () {

// minitest first

collection _c;
object *a = new object ();
object *b = new object ();

_c.add (a);
_c.add (b);
_c.add (a);
_c.add (b);
collection *result = new collection (_c);

for (unsigned i = 0; i < _c.getSize (); i++) {
   if (result->instanceCount (*_c[i]) > 0)
      result->remove (result->indexOf (*_c[i]));
   }

// end of minitest

object** testobjects = new object * [ARRAY_SIZE];

for (unsigned i = 0; i < ARRAY_SIZE; i++) 
   testobjects[i] = new object ();

collection l;

l.add (testobjects[0]);
l.add (testobjects[0]);
assert (l.instanceCount (*testobjects[0]) == 2);
l.remove (0);
l.remove (0);
assert (l.getSize () == 0);
assert (l.instanceCount (*testobjects[0]) == 0);

assert (l.getSize () == 0);
assert (l.getCapacity () == DEFAULT_CONTAINER_CAPACITY);

for (unsigned i = 0; i < ARRAY_SIZE; i++) {
	l.add (testobjects[i]);
   assert (l.getSize () == i + 1);
   assert (l[i] == testobjects[i]);
   assert (*l[i] == *testobjects[i]);
   assert (l.indexOf (*l[i]) == i);
   assert (l.instanceCount (*l[i]) == 1);
   }

for (unsigned i = 0; i < l.getSize () / 2; i++) {
   l.swap (i, ARRAY_SIZE - i - 1);
   assert (*l[i] == *testobjects[ARRAY_SIZE - i - 1]);
   }

for (unsigned i = 0; i < l.getSize () / 2; i++) {
   l.swap (i, ARRAY_SIZE - i - 1);
   }

unsigned size = l.getSize ();
for (unsigned i = 0; i < size / 2; i++) {
   object *temp = l[0];
   assert (*l.remove(0) == *temp);
   assert (l.instanceCount (*temp) == 0);
   }

collection store (l);
l.trim ();

assert (l.getSize () == ARRAY_SIZE - ARRAY_SIZE / 2);
assert (l.getCapacity () == l.getSize ());

for (unsigned i = 0; i < l.getSize (); i++) {
   assert (*l[i] == *store[i]);
   }


collection al (l); 


for (unsigned i = 0; i < l.getSize (); i++) {
   assert (al[i] == l[i]);
   }

size = al.getSize ();

for (unsigned i = 0; i < size; i++) {
   al.remove (i);
   }

assert (al.getSize () == 0);

size = 0;
for (unsigned j = 0; j < 2; j++) {
   for (unsigned i = 0; i < ARRAY_SIZE; i++) {
      size++;
		al.add (testobjects[i]);
      assert (al.getSize () == size);
      assert (al[i] == testobjects[i]);
      assert (*al[i] == *testobjects[i]);
      assert (al.instanceCount (*al[i]) == j + 1);
      }
   }


size = al.getSize ();
for (unsigned i = 0; i < size / 2 + 1; i++) {
   al.remove (i);
   }

for (unsigned i = 0; i < store.getSize (); i++) {
   l.remove (l.indexOf (*store[i]));
   }

l.removeAll ();
_c.removeAll ();
store.removeAll ();
al.empty ();
assert (al.getSize () == 0);

}

