#include <adevs/adevs.h>
#include <assert.h>
#include <iostream>
using namespace adevs;

#define ARRAY_SIZE 100

int main () {

object** u = new object * [ARRAY_SIZE];
object** v = new object * [ARRAY_SIZE];

digraph g;

for (unsigned i = 0; i < ARRAY_SIZE; i++) {
   u[i] = new object ();
   v[i] = new object ();
   }

for (unsigned i = 0; i < ARRAY_SIZE; i++) {
   assert (g.verticeCount () == i * 2);
   assert (g.edgeCount () == i * 2);
   g.addVertice (u[i]);
   g.addVertice (v[i]);
   assert (g.hasVertice (*u[i]));
   assert (g.hasVertice (*v[i]));
   g.addEdge (*u[i], *v[i]);
   g.addEdge (*v[i], *u[i]);
   assert (g.adjacent (*u[i], *v[i]));
   assert (g.adjacent (*v[i], *u[i]));
   }

for (unsigned i = 0; i < ARRAY_SIZE; i++) {
   assert (g.verticeCount () == ARRAY_SIZE * 2 - i * 2);
   assert (g.edgeCount () == g.verticeCount ());

   if (i % 2 == 0) {
      assert (g.removeVertice (*u[i]) == u[i]);
      assert (!g.hasVertice (*u[i]));
      assert (!g.adjacent (*v[i], *u[i]));
      assert (g.removeVertice (*v[i]) == v[i]);
      }

   else {
      g.removeEdge (*u[i], *v[i]);
      assert (!g.adjacent (*u[i], *v[i]));
      assert (g.adjacent (*v[i], *u[i]));
      assert (g.removeVertice (*v[i]) == v[i]);
      assert (g.removeVertice (*u[i]) == u[i]);
      }

   }

}

