/***********
Copyright (C) 1999, 2000  James Nutaro

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

Bugs, comments, and questions can be sent to nutaro@ece.arizona.edu
***************/
#include "message.h"
#include "channel.h"
#include <iostream>
#include <assert.h>
using namespace adevs;

const port_t channel::in = 0;
const port_t channel::out = 1;

channel::channel (stime_t max_delay):atomic ("channel") {

m_out = NULL;
this->max_delay = max_delay;
addInputPort (in);
addOutputPort (out);

}

void channel::reset () {

delay_list.empty ();
if (m_out != NULL) delete m_out;
m_out = NULL;
passivate ();

}

void channel::delta_int () {

m_out = (message*)delay_list.remove ();
if (m_out == NULL) passivate ();
else hold ((double)random () / (double)RAND_MAX * max_delay);

}


void channel::delta_ext () {

bag* values = inputOnPort (in);
for (unsigned i = 0; i < values->getSize (); i++) {
   message* e = (message*)values->getObj (i);
   delay_list.add (new message (*e));
   }

if (m_out == NULL) {
   m_out = (message*)delay_list.remove ();
   hold ((double)random () / (double)RAND_MAX * max_delay);
   }

}

void channel::delta_conf () {

delta_int ();
delta_ext ();

}

void channel::output_func () {

if (m_out != NULL) output (out, m_out);

}

channel::~channel () {

delay_list.empty ();
if (m_out != NULL) delete m_out;

}
