/***********
Copyright (C) 1999, 2000  James Nutaro

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

Bugs, comments, and questions can be sent to nutaro@ece.arizona.edu
***************/
/**

Model of a FIFO channel with a uniform random delay.

*/

class channel: public adevs::atomic {

public:
// creates a channel with a delay ~ uniform (0, max_delay)
	channel (adevs::stime_t max_delay);

	void reset ();
	void delta_int ();
	void delta_ext ();
	void delta_conf ();
	void output_func ();

	~channel ();

// input port expects message objects
	static const adevs::port_t in;

// output port produces message objects
	static const adevs::port_t out; 

private:

// state

// max delay time
	adevs::stime_t max_delay;
// message queue
	adevs::queue delay_list;
// next message out
	message* m_out;

};
