
/*
Cell in a 1D linear systolic array that will be implementing
a step in a systolic convolution algorithm.  The systolic algorithm
works by keeping the weights in position, while the x's any y's
move systolically in the same direction.
*/

class systolicCell: public adevs::atomic {

public:		systolicCell (double weight);

// transition functions
		void delta_int ();
		void delta_ext ();
		void delta_conf ();
// reset and initialization function
		void reset ();
// output function
		void output_func ();

// port definitions
		static const adevs::port_t yin;
		static const adevs::port_t yout;
		static const adevs::port_t xin;
		static const adevs::port_t xout;

		~systolicCell ();

private:	adevs::dbl* x;
		adevs::dbl* x_in;
		adevs::dbl* y_out;
		double w;

};

