#include <list>
#include <map>
#include <adevs/adevs.h>
#include "OS.h"
using namespace adevs;

const port_t OS::out = 0;
const port_t OS::in = 1;

OS::OS (int num_procs, stime_t obs_time, stime_t genr_period,
		stime_t job_size, int job_limit):staticDigraph ("ef") {

setThreaded (false);
addInputPort (in);
addOutputPort (out);

l = new lb (num_procs);
t = new transd (obs_time);
g = new genr (genr_period, job_size, job_limit);

add (l);
add (t);
add (g);

couple (g, g->out, t, t->ariv);
couple (t, t->stop, g, g->stop);
couple (g, g->out, l, l->in);
couple (l, l->out, this, this->out);

couple (this, in, t, t->solv);
couple (this, in, l, l->load);

}
