/***********
Copyright (C) 1999, 2000  James Nutaro

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

Bugs, comments, and questions can be sent to nutaro@ece.arizona.edu
***************/
/**
Block's are used to represent walls and, um, blocks.
*/

class block: public adevs::atomic {

public:
	block ();
// create a block with a given shape.
	block (const rectangle& geom_init);
// create a block with a shape and fixed status (normally INVULNERABLE).
	block (const rectangle& geom_init, eStatus stat);

	void reset ();
	void delta_int ();
	void delta_ext ();
	void delta_conf ();
	void output_func ();

	~block ();

// input ports
	static const adevs::port_t ball_motion;
	static const adevs::port_t paddle_motion;

// output ports
	static const adevs::port_t status; 
	static const adevs::port_t ball_collision;
	static const adevs::port_t paddle_collision;

private:

// initial state
	rectangle geom_init;
	bool fixed;
	eStatus stat_init;

// state
	eStatus stat;
	bool report_status;
	adevs::indexed ball_collisions;
	adevs::indexed paddle_collisions;
	rectangle geom;

};

