/***********
Copyright (C) 1999, 2000  James Nutaro

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

Bugs, comments, and questions can be sent to nutaro@ece.arizona.edu
***************/
#include <adevs/adevs.h>
#include <stdlib.h>
#include <math.h>
#include "shapes.h"
using namespace adevs;

bool circle::contains (double x, double y) const {

vector v (getX () - x, getY () - y);
return (v.length () <= radius);

}

bool circle::contains (const vector& pos) const {

vector v = getPosition() - pos;
return (v.length() <= radius);

}

double circle::surfaceAngle (double x, double y) const { 

vector p (x-getX(), y-getY());
return asin (p.y / p.length ());

}

double circle::surfaceAngle (const vector& pos) const { 

vector p = pos - getPosition ();
return asin (p.y / p.length ());

}

bool circle::overlaps (const circle& c) const {

vector l = c.getPosition() - getPosition ();
return (l.length () < (c.getRadius()+radius));

}

bool circle::overlaps (const rectangle& r) const {

return r.overlaps (*this);

}

shape& circle::operator= (const shape& s) {

shape::operator=(s);
const circle* c = dynamic_cast<const circle*> (&s);
if (c != NULL) {
   radius = c->radius;
   }
return *this;

}

circle::~circle () { }
