/***************
adevs, a library supporting discrete event simulation
Copyright (C) 1999, 2000, 2001 James Nutaro

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

Bugs, comments, and questions can be sent to nutaro@ece.arizona.edu
***************/
#include <stdio.h>
#include <adevs/adevs.h>
using namespace adevs;

UndefinedException::UndefinedException (const devs* model)
:ModelException (model) {

port = NULL;
errmsg.append ("Undefined: ");
errmsg.append (model->getName ());
errmsg.append ("\n");

}

UndefinedException::UndefinedException (const UndefinedException& src)
:ModelException (src) {

if (src.port != NULL)
   this->port = new Port (*src.port);
else this->port = NULL;

}

UndefinedException::UndefinedException (const devs* model, port_t port)
:ModelException (model) {

this->port = new Port (port);
errmsg.append ("Undefined: ");
errmsg.append (model->getName ());
errmsg.append (".");
char temp [20];
sprintf (temp, "%d\n", port);
errmsg.append (temp);
 
}

bool UndefinedException::undefinedPort () const {

return port != NULL;

}

bool UndefinedException::undefinedModel () const {

return port == NULL;

}

UndefinedException::~UndefinedException () {

if (port != NULL) delete port;

} 
