#include <adevs/adevs.h>
#include "cell.h"
#include "cell_exec.h"
using namespace adevs;

const port_t cell_exec::death = 0;
const port_t cell_exec::birth = 1;

cell_exec::cell_exec ():networkExec () {

addInputPort (death);
addInputPort (birth);

}

void cell_exec::reset () {

pop = 1;
cell* first = new cell ();
add (first);
passivate ();

}

void cell_exec::delta_int () { 

passivate ();

}

void cell_exec::delta_ext () { 

bag* values = inputOnPort (death);
for (unsigned i = 0; i < values->getSize(); i++) {
   object* cell_id = ((obj_ptr*)(values->getObj (i)))->value;
   remove ((devs*)cell_id);
   pop--;
   }
values = inputOnPort (birth);
for (unsigned i = 0; i < values->getSize(); i++) {
   add (new cell ());
   pop++;
   }
passivate ();

}

void cell_exec::delta_conf () { }
void cell_exec::output_func () { }

const indexed* cell_exec::computeNeighbors (devs& model, const port_value& pv) {

coupling.empty ();
if (pv.port == cell::die)
   coupling.add (new EventReceiver (this, death));
else
   coupling.add (new EventReceiver (this, birth));
return &coupling;

}

cell_exec::~cell_exec () {

coupling.empty ();

}

